-- ACKNOWLEDGEMENT
-- yatima @ https://www.wowhead.com/quest=57235/solar-collector#comments
-- Notviable-TarrenMill @ https://wago.io/ghZoKFGj4

-- CurseForge: https://www.curseforge.com/wow/addons/solarcollector/
-- Homepage: https://loneskyimages.blogspot.com/2020/05/wow-solar-collector-puzzle-addon.html
-- https://tinyurl.com/SolarCollectorAddon
-- https://tinyurl.com/SolarCollectorAddonDownload (direct download)
local version = "1.0.0"

---------- FRAMES ----------

-- BASE FRAME
local baseFrame = CreateFrame("Frame", nil, UIParent)
baseFrame:SetWidth(145)
baseFrame:SetHeight(130)
baseFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = {left = 4, right = 4, top = 4, bottom = 4}
})
baseFrame:SetBackdropColor(0, 0, 0, 0.66)
baseFrame:SetPoint("CENTER", 250, -130)
baseFrame:SetMovable(true)
baseFrame:EnableMouse(true)
baseFrame:RegisterForDrag("LeftButton")
baseFrame:Hide()

-- TITLE FRAME
local titleFrame = CreateFrame("Frame", nil, baseFrame)
titleFrame:SetWidth(145)
titleFrame:SetHeight(24)
titleFrame:SetPoint("TOPLEFT", 0, 0)
titleFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = {left = 4, right = 4, top = 4, bottom = 4}
})
titleFrame:SetBackdropColor(0, 0, 0, 0.66)
-- TITLE FRAME TEXT
local titleText = titleFrame:CreateFontString(nil, "OVERLAY")
titleText:SetPoint("LEFT", 10, 0)
titleText:SetFont("Fonts\\FRIZQT__.ttf", 10, "OUTLINE")
titleText:SetText("Solar Collector Quest")

-- INFO FRAME
local infoFrame = CreateFrame("Frame", nil, baseFrame)
infoFrame:SetWidth(200)
infoFrame:SetHeight(130)
infoFrame:SetPoint("BOTTOMRIGHT", 194, 0)
infoFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
	tile = true, tileSize = 16, edgeSize = 16, 
	insets = {left = 4, right = 4, top = 4, bottom = 4}
})
infoFrame:SetBackdropColor(0, 0, 0, 0.66)
infoFrame:Hide()
-- INFO FRAME TEXT
local infoText = infoFrame:CreateFontString(nil, "OVERLAY")
infoText:SetPoint("TOPLEFT", 10, -14)
infoText:SetFont("Fonts\\ARIALN.ttf", 12, "OUTLINE")
infoText:SetJustifyH("LEFT")

-- CONTROL FRAME
local controlFrame = CreateFrame("Frame")
controlFrame:Hide()

-- INFO BUTTON
local infoButton = CreateFrame("Button", "infoButton", titleFrame, "UIPanelInfoButton")
infoButton:SetPoint("LEFT", -7, 7)

-- CLOSE BUTTON
local closeButton = CreateFrame("Button", "closeButton", titleFrame, "UIPanelCloseButton")
closeButton:SetPoint("RIGHT", -2, 0)
closeButton:SetSize(20, 20)

-- CHECK BUTTONS
local checkButton5 = CreateFrame("CheckButton", "checkButton5", baseFrame, "ChatConfigCheckButtonTemplate")
checkButton5:SetPoint("TOPLEFT", 101, -24)

local checkButton4 = CreateFrame("CheckButton", "checkButton4", baseFrame, "ChatConfigCheckButtonTemplate")
checkButton4:SetPoint("TOPLEFT", 81, -46)

local checkButton3 = CreateFrame("CheckButton", "checkButton3", baseFrame, "ChatConfigCheckButtonTemplate")
checkButton3:SetPoint("TOPLEFT", 61, -24)

local checkButton2 = CreateFrame("CheckButton", "checkButton2", baseFrame, "ChatConfigCheckButtonTemplate")
checkButton2:SetPoint("TOPLEFT", 41, -46)

local checkButton1 = CreateFrame("CheckButton", "checkButton1", baseFrame, "ChatConfigCheckButtonTemplate")
checkButton1:SetPoint("TOPLEFT", 21, -24)

-- CONTROL BUTTON
local controlButton = CreateFrame("CheckButton", "controlButton", baseFrame, "ChatConfigCheckButtonTemplate")
controlButton:SetPoint("TOPLEFT", 101, -46)
controlButton:SetFrameStrata("BACKGROUND")
controlButton:EnableMouse(false)
controlButton:SetAlpha(0)

-- SOLVE BUTTON
local solveButton = CreateFrame("Button", "solveButton", baseFrame, "UIPanelButtonTemplate")
solveButton:SetSize(60, 22)
solveButton:SetText("Solve")
solveButton:SetPoint("BOTTOMLEFT", 10, 36)

-- RESET BUTTON
local resetButton = CreateFrame("Button", "resetButton", baseFrame, "UIPanelButtonTemplate")
resetButton:SetSize(60, 22)
resetButton:SetText("Reset")
resetButton:SetPoint("BOTTOMRIGHT", -11, 36)

-- MODE BUTTON
local modeButton = CreateFrame("Button", "modeButton", baseFrame, "UIPanelButtonTemplate")
modeButton:SetSize(124, 22)
modeButton:SetText("Puzzle Mode")
modeButton:SetPoint("BOTTOMLEFT", 10, 11)

-- LOCK BUTTON
local lockButton = CreateFrame("CheckButton", "lockButton", infoFrame, "ChatConfigCheckButtonTemplate")
lockButton:SetPoint("TOPLEFT", 10, -8)
-- LOCK BUTTON TEXT
local lockButtonText = lockButton:CreateFontString(nil, "OVERLAY")
lockButtonText:SetPoint("LEFT", 28, 0)
lockButtonText:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE")
lockButtonText:SetText("Lock window position")

-- SOUND BUTTON
local soundButton = CreateFrame("CheckButton", "soundButton", infoFrame, "ChatConfigCheckButtonTemplate")
soundButton:SetPoint("TOPLEFT", 10, -28)
-- SOUND BUTTON TEXT
local soundButtonText = soundButton:CreateFontString(nil, "OVERLAY")
soundButtonText:SetPoint("LEFT", 28, 0)
soundButtonText:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE")
soundButtonText:SetText("Turn sound off")

-- AUTO HELP BUTTON
local autoHelpButton = CreateFrame("CheckButton", "autoHelpButton", infoFrame, "ChatConfigCheckButtonTemplate")
autoHelpButton:SetPoint("TOPLEFT", 10, -48)
-- AUTO HELP BUTTON TEXT
local autoHelpButtonText = autoHelpButton:CreateFontString(nil, "OVERLAY")
autoHelpButtonText:SetPoint("LEFT", 28, 0)
autoHelpButtonText:SetFont("Fonts\\FRIZQT__.ttf", 11, "OUTLINE")
autoHelpButtonText:SetText("Turn automatic help on")

-- SHOW HELP BUTTON
local showHelpButton = CreateFrame("Button", "showHelpButton", infoFrame, "UIPanelButtonTemplate")
showHelpButton:SetSize(49, 22)
showHelpButton:SetText("Help")
showHelpButton:SetPoint("BOTTOMLEFT", 10, 36)

-- SHOW COMMANDS BUTTON
local showCommandsButton = CreateFrame("Button", "showCommandsButton", infoFrame, "UIPanelButtonTemplate")
showCommandsButton:SetSize(85, 22)
showCommandsButton:SetText("Commands")
showCommandsButton:SetPoint("BOTTOMLEFT", 63, 36)

-- RESET POSITION BUTTON
local resetPositionButton = CreateFrame("Button", "resetPositionButton", infoFrame, "UIPanelButtonTemplate")
resetPositionButton:SetSize(138, 22) -- (105, 22)
resetPositionButton:SetText("Reset Position")
resetPositionButton:SetPoint("BOTTOMLEFT", 10, 11)

-- DOWN BUTTON
local downButton = CreateFrame("Button", "downButton", infoFrame, "UIPanelScrollDownButtonTemplate")
downButton:SetPoint("BOTTOMRIGHT", -8, 8)
downButton:SetWidth(15)
downButton:SetHeight(13)

-- UP BUTTON
local upButton = CreateFrame("Button", "upButton", infoFrame, "UIPanelScrollUpButtonTemplate")
upButton:SetPoint("BOTTOMRIGHT", -8, 8)
upButton:SetWidth(15)
upButton:SetHeight(13)
upButton:Hide()

---------- TABLES ----------

local assets = {
	"lockButton",
	"soundButton",
	"autoHelpButton",
	"showHelpButton",
	"showCommandsButton",
	"resetPositionButton",
}

-- CHECK BUTTONS
local cb = {
	"checkButton1",
	"checkButton2",
	"checkButton3",
	"checkButton4",
	"checkButton5",
}

-- CHECK BUTTON SEQUENCE
local cbSequence = {
	["00000"] = "3",
	["10000"] = "4",
	["01000"] = "3, 4, 5",
	["11000"] = "5",
	["00100"] = "1, 5",
	["10100"] = "1, 3, 4, 5",
	["01100"] = "1, 4",
	["11100"] = "1, 3",
	["00010"] = "1, 2, 3",
	["10010"] = "1, 2, 4",
	["01010"] = "1, 2, 3, 4, 5",
	["11010"] = "1, 2, 5",
	["00110"] = "2, 5",
	["10110"] = "2, 3, 4, 5",
	["01110"] = "2, 4",
	["11110"] = "2, 3",
	["00001"] = "2",
	["10001"] = "2, 3, 4",
	["01001"] = "2, 4, 5",
	["11001"] = "2, 3, 5",
	["00101"] = "1, 2, 3, 5",
	["10101"] = "1, 2, 4, 5",
	["01101"] = "1, 2, 3, 4",
	["11101"] = "1, 2",
	["00011"] = "1",
	["10011"] = "1, 3, 4",
	["01011"] = "1, 4, 5",
	["11011"] = "1, 3, 5",
	["00111"] = "3, 5",
	["10111"] = "4, 5",
	["01111"] = "3, 4",
	["11111"] = "",
}

---------- QUESTS ----------

local quest1 = (C_TaskQuest.IsActive(57234) or IsQuestFlaggedCompleted(57234) == true)
local quest2 = (C_TaskQuest.IsActive(57235) or IsQuestFlaggedCompleted(57235) == true)

---------- INFO TEXT ----------

local scText = "|cffffeeaaSolar Collector:|r "
local loadText1, loadText2 = "|cffffeeaaSolarCollector|r ", " loaded! Type |cffffeeaa/SolarCollector|r or |cffffeeaa/sc|r for options."
local activationText = scText.."Addon activated! Click the Info button for help."
local reminderText = scText.."Type |cffffeeaa/sc show|r to reactivate addon."
local reminderTextUldum = scText.."Type |cffffeeaa/sc show|r to reactivate addon."
local autoDetectText = "Automatic detection resumes in 30 seconds while in Uldum."
local errorText1, errorText2 = scText.."No action necessary. Click the ", " button or start a new sequence."
local showHelpText = scText.."The Mode button toggles between quest mode and puzzle mode as indicated in the title bar. Turn on quest mode to do the quest in Uldum. Switch to puzzle mode to convert the addon into a mini game. Press the Info button for context help and addon options."
local autoHelpQuestText = scText.."Be sure quest mode is on for the quest in Uldum. The addon buttons are arranged in a pattern similar to the triangles on the ground. Reproduce the sequence of illuminated triangles by clicking the corresponding buttons. Press the Solve button for the solution sequence. Activate the triangles in any order so that they match the solution pattern. Press the Reset button to begin a new sequence."
local autoHelpPuzzleText = scText.."The object of the game is to activate all five buttons. Each time you click a button it will reverse the state of that button and all the buttons adjacent to it. If you get stumped, press the Solve button then click each illuminated button. The order does not matter but it is good practice to click from left-to-right. Press the Shuffle button to start a new game. Good luck!"
local windowLockText = scText.."Window position locked."
local windowUnlockText = scText.."Window position unlocked."
local soundOffText = scText.."Sound disabled."
local soundOnText = scText.."Sound enabled."
local positionResetText = scText.."Window position reset."

local questText = 
[[Click the buttons so that they match
the pattern of illuminated triangles.

Press the Solve button.

Activate the triangles corresponding
to the glowing buttons to complete
the sequence.]]

local gameText = 
[[Activate all five buttons to win game.

Press the Solve button and click the
glowing buttons for the solution to
the puzzle.

Press the Shuffle button to randomize
the buttons or start a new game.]]

local slashText = 
[[|cffffeeaaSolarCollector|r commands:
Type |cffffeeaa/sc help|r for help instructions.
Type |cffffeeaa/sc lock|r to lock window position.
Type |cffffeeaa/sc unlock|r to unlock window position.
Type |cffffeeaa/sc reset|r to reset window position.
Type |cffffeeaa/sc hide|r to hide addon.
Type |cffffeeaa/sc show|r to show addon.
Type |cffffeeaa/SolarCollector|r or |cffffeeaa/sc|r for these options.]]

---------- FUNCTIONS ----------

-- GET MAP INFO
local function getMapInfo()
	local map = C_Map.GetBestMapForUnit("player")
	if map then
		local position = C_Map.GetPlayerMapPosition(map, "player")
		if position then
			x, y = position:GetXY()
		end
	end
	return map, x, y
end

-- BUTTON TO NUMBER
local function b2n(v)
	return v and 1 or 0
end

-- USER INPUT VALUE
local function userInputValue()
	local cb1 = b2n(checkButton1:GetChecked())
	local cb2 = b2n(checkButton2:GetChecked())
	local cb3 = b2n(checkButton3:GetChecked())
	local cb4 = b2n(checkButton4:GetChecked())
	local cb5 = b2n(checkButton5:GetChecked())
	userInput = cb1..cb2..cb3..cb4..cb5
	return userInput
end

-- INFO TEXT SET
local function infoTextSet()
	if modeButton:GetText() == "Puzzle Mode" then
		infoText:SetText(questText)
--	elseif modeButton:GetText() == "Quest Mode" then
	else
		infoText:SetText(gameText)
	end
	for _, v in ipairs(assets) do
		_G[v]:Hide()
	end
	upButton:Hide()
	downButton:Show()
end

-- AUTO DETECT TEXT SET
local function autoDetectTextSet()
	if getMapInfo(map) == 1527 and (quest1 or quest2) then
		if autoHelpButton:GetChecked() == true then print(reminderTextUldum, autoDetectText) end
		C_Timer.After(30, function()
			controlFrame:Show()
		end)
	else
		if autoHelpButton:GetChecked() == true then print(reminderText) end
	end
end

-- RANDOMIZE BUTTONS
local function randomizeButtons()
	for _, v in ipairs(cb) do
		local r = math.random(0, 1)
		if (r == 1) then
			_G[v]:SetChecked(true)
		end
	end
end

-- RESET ALL BUTTONS
local function resetAllButtons()
	for _, v in ipairs(cb) do
		_G[v]:SetChecked(false)
		_G[v]:Enable()
		ActionButton_HideOverlayGlow(_G[v])
	end
	controlButton:SetChecked(false)
end

-- FLIP BUTTON
local function flipButton(button)
	if modeButton:GetText() == "Quest Mode" then
		if button:GetChecked(true) then button:SetChecked(false) else button:SetChecked(true) end
	end
end

-- OVERLAY SET
local function overlaySet()
	if modeButton:GetText() == "Quest Mode" and userInputValue() == "11111" then
		controlButton:SetChecked(true)
		for _, v in ipairs(cb) do
			ActionButton_ShowOverlayGlow(_G[v])
			_G[v]:SetButtonState("NORMAL")
		end
		if soundButton:GetChecked() == false then PlaySound(1204) end
		-- UIErrorsFrame:AddMessage("You win!")
	end
	if modeButton:GetText() == "Quest Mode" and userInputValue() ~= "11111" and controlButton:GetChecked() == true then
		controlButton:SetChecked(false)
		for _, v in ipairs(cb) do
			ActionButton_HideOverlayGlow(_G[v])
		end
	end
end

-- BASE FRAME
baseFrame:SetScript("OnDragStart", baseFrame.StartMoving)
baseFrame:SetScript("OnDragStop", baseFrame.StopMovingOrSizing)

-- INFO BUTTON
infoButton:SetScript("OnClick", function()
	if infoFrame:IsShown() then
		infoFrame:Hide()
	else
		infoFrame:Show()
	end
	infoTextSet()
end)

-- CLOSE BUTTON
closeButton:SetScript("OnClick", function()
	baseFrame:Hide()
	controlFrame:Hide()
	autoDetectTextSet()
end)

-- CHECK BUTTONS
checkButton5:SetScript("OnClick", function()
	flipButton(checkButton3)
	flipButton(checkButton4)
	overlaySet()
end)

checkButton4:SetScript("OnClick", function()
	flipButton(checkButton2)
	flipButton(checkButton3)
	flipButton(checkButton5)
	overlaySet()
end)

checkButton3:SetScript("OnClick", function()
	flipButton(checkButton1)
	flipButton(checkButton2)
	flipButton(checkButton4)
	flipButton(checkButton5)
	overlaySet()
end)

checkButton2:SetScript("OnClick", function()
	flipButton(checkButton1)
	flipButton(checkButton3)
	flipButton(checkButton4)
	overlaySet()
end)

checkButton1:SetScript("OnClick", function()
	flipButton(checkButton2)
	flipButton(checkButton3)
	overlaySet()
end)

-- SOLVE BUTTON
solveButton:SetScript("OnClick", function()
	if modeButton:GetText() == "Puzzle Mode" and controlButton:GetChecked() == true then
		do return end
	end
	for w in cbSequence[userInputValue()]:gmatch("%w+") do
		assert(loadstring("ActionButton_ShowOverlayGlow(checkButton"..w..")"))()
	end
	if modeButton:GetText() == "Puzzle Mode" and userInputValue() ~= "11111" then
		for _, v in ipairs(cb) do
			_G[v]:SetChecked(false)
			_G[v]:Disable()
		end
		controlButton:SetChecked(true)
	end
	if userInputValue() == "11111" then
		local button = "Reset"
		if modeButton:GetText() == "Quest Mode" then
			button = "Shuffle"
		end
		if autoHelpButton:GetChecked() == true then print(errorText1..button..errorText2) end
	end
end)

-- RESET BUTTON
resetButton:SetScript("OnClick", function()
	resetAllButtons()
	if modeButton:GetText() == "Quest Mode" then
		randomizeButtons()
	end
end)

-- MODE BUTTON
modeButton:SetScript("OnClick", function()
	if modeButton:GetText() == "Puzzle Mode" then
		titleText:SetText("Solar Collector Puzzle")
		modeButton:SetText("Quest Mode")
		resetButton:SetText("Shuffle")
		if autoHelpButton:GetChecked() == true then print(autoHelpPuzzleText) end
	elseif modeButton:GetText() == "Quest Mode" then
		titleText:SetText("Solar Collector Quest")
		modeButton:SetText("Puzzle Mode")
		resetButton:SetText("Reset")
		if autoHelpButton:GetChecked() == true then print(autoHelpQuestText) end
	end
	resetAllButtons()
	controlButton:SetChecked(false)
	if modeButton:GetText() == "Quest Mode" then randomizeButtons() end
	infoTextSet()
	downButton:Show()
	upButton:Hide()
end)

-- LOCK BUTTON
lockButton:SetScript("OnClick", function()
	if autoHelpButton:GetChecked() == true then
		if lockButton:GetChecked() == true then
			print(windowLockText)
		else
			print(windowUnlockText)
		end
	end
	if lockButton:GetChecked() == true then
		baseFrame:SetMovable(false)
		baseFrame:SetScript("OnDragStart", nil)
	else
		baseFrame:SetMovable(true)
		baseFrame:SetScript("OnDragStart", baseFrame.StartMoving)
	end
end)

-- SOUND BUTTON
soundButton:SetScript("OnClick", function()
	if autoHelpButton:GetChecked() == true then
		if soundButton:GetChecked() == true then
			print(soundOffText)
		else
			print(soundOnText)
		end
	end
end)

-- AUTO HELP BUTTON
autoHelpButton:SetScript("OnClick", function()
	if autoHelpButton:GetChecked() == true then
		if autoHelpButton:GetChecked() == true then
			print("|cffffeeaaSolar Collector:|r Automatic help activated.")
		end
	end
end)

-- SHOW HELP BUTTON
showHelpButton:SetScript("OnClick", function()
	print(showHelpText)
end)

-- SHOW COMMANDS BUTTON
showCommandsButton:SetScript("OnClick", function()
	print(slashText)
end)

-- RESET POSITION BUTTON
resetPositionButton:SetScript("OnClick", function()
	if autoHelpButton:GetChecked() == true then print("|cffffeeaaSolar Collector:|r Window position reset.") end
	baseFrame:ClearAllPoints()
	baseFrame:SetPoint("CENTER", 250, -130)
end)

-- DOWN BUTTON
downButton:SetScript("OnClick", function()
	infoText:SetText("")
	for _, v in ipairs(assets) do
		_G[v]:Show()
	end
	downButton:Hide()
	upButton:Show()
end)

-- UP BUTTON
upButton:SetScript("OnClick", function()
	infoTextSet()
end)

-- SHOW ADDON WHEN NEAR QUEST
baseFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
baseFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
baseFrame:SetScript("OnEvent", function(self, event, ...)
	local ONUPDATE_INTERVAL = 2
	local delta = 0
	controlFrame:Show()
	controlFrame:SetScript("OnUpdate", function(self, elapsed)
		if baseFrame:IsShown() or not (getMapInfo(map) == 1527 and (quest1 or quest2)) then
			controlFrame:Hide()
			return
		end
		delta = delta + elapsed
		if delta >= ONUPDATE_INTERVAL then
			delta = 0
			getMapInfo(x, y)
			-- quest1 coordinates: 80.2, 66.1
			-- quest2 coordinates: 66.5, 50.3
			if quest1 and (x > 0.787 and x < 0.817) and (y > 0.651 and y < 0.671) 
			or quest2 and (x > 0.650 and x < 0.680) and (y > 0.493 and y < 0.513) then
				if not baseFrame:IsShown() then
					baseFrame:Show()
					if modeButton:GetText() == "Quest Mode" then modeButton:Click() end
					if soundButton:GetChecked() == false then PlaySound(23437) end
					if autoHelpButton:GetChecked() == true then print(activationText) end
					controlFrame:Hide()
				end
			end
		end
	end)
end)

-- LOAD TEXT
print(loadText1..version..loadText2)

-- SLASH COMMANDS
SLASH_SOLARCOLLECTOR1 = "/SolarCollector"
SLASH_SOLARCOLLECTOR2 = "/sc"
local function handler(msg, editbox)
	if (msg == "help") then
		print(showHelpText)
	elseif (msg == "lock") then
		baseFrame:SetMovable(false)
		baseFrame:SetScript("OnDragStart", nil)
		if autoHelpButton:GetChecked() == true then print(windowLockText) end
	elseif (msg == "unlock") then
		baseFrame:SetMovable(true)
		baseFrame:SetScript("OnDragStart", baseFrame.StartMoving)
		if autoHelpButton:GetChecked() == true then print(windowUnlockText) end
	elseif (msg == "reset") then
		baseFrame:ClearAllPoints()
		baseFrame:SetPoint("CENTER", 250, -130)
		if autoHelpButton:GetChecked() == true then print(positionResetText) end
	elseif (msg == "hide") then
		if autoHelpButton:GetChecked() == true then
			if baseFrame:IsShown() then
				print(scText.."Addon hidden.")
				autoDetectTextSet()
			end
		end
		baseFrame:Hide()
	elseif (msg == "show") then
		baseFrame:Show()
		if autoHelpButton:GetChecked() == true then print(scText.."Addon shown.") end
	else
		print(slashText)
	end
end
SlashCmdList["SOLARCOLLECTOR"] = handler